/*
	Author: Kanad Mehta | Incepto | kanad@incepto.com.au
	Purpose: Call a GET or POST API and return response
*/

CREATE FUNCTION Call_GetPostAPI
(
    @method VARCHAR(5),
    @url VARCHAR(8000),
    @token NVARCHAR(2000),
    @params NVARCHAR(4000)
)
RETURNS VARCHAR(8000)
AS 

BEGIN
	DECLARE @authHeader NVARCHAR(2000);
	DECLARE @contentType NVARCHAR(64);
	DECLARE @postData NVARCHAR(2000);
	DECLARE @responseText NVARCHAR(4000);
	DECLARE @responseXML NVARCHAR(4000);

	DECLARE @ret INT;
	DECLARE @status NVARCHAR(32);
	DECLARE @statusText NVARCHAR(32);
	DECLARE @internalToken INT;

	SET @authHeader= 'Bearer ' + @token;
	SET @contentType = 'application/json';

	-- Open the connection.
	EXEC @ret = sp_OACreate 'WinHttp.WinHttpRequest.5.1', @internalToken OUT;
	--IF @ret <> 0 RAISERROR('Unable to open HTTP connection.', 10, 1);

	-- Send the request.
	EXEC @ret = sp_OAMethod @internalToken, 'open', NULL, @method, @url, 'false';
	EXEC @ret = sp_OAMethod @internalToken, 'setRequestHeader', NULL, 'Authorization', @authHeader; 
	if @ret <> 0 
		  begin 
				set @ret = 'sp_OAMethod setRequestHeader failed' 
		  end
	EXEC @ret = sp_OAMethod @internalToken, 'setRequestHeader', NULL, 'Content-type', @contentType;

	EXEC @ret = sp_OAMethod @internalToken, 'send', NULL, @params;

	-- Handle the response.
	EXEC @ret = sp_OAGetProperty @internalToken, 'status', @status OUT;
	EXEC @ret = sp_OAGetProperty @internalToken, 'statusText', @statusText OUT;
	EXEC @ret = sp_OAGetProperty @internalToken, 'responseText', @responseText OUT;

	-- Show the response.
	--PRINT 'Status: ' + @status + ' (' + @statusText + ')';
	--PRINT 'Response text: ' + @responseText;

	-- Close the connection.
	EXEC @ret = sp_OADestroy @internalToken;
	--IF @ret <> 0 RAISERROR('Unable to close HTTP connection.', 10, 1);

	RETURN @responseText
END