/*
	Author: Kanad Mehta | Incepto | kanad@incepto.com.au
	Purpose: To illustrate calling UiPath Orchestrator API from SQL
	Refer https://postman.uipath.rocks/ for details
*/

DECLARE @method varchar(5) -- Method Get/ Post
DECLARE @url varchar(8000) -- Complete API URL
DECLARE @token NVARCHAR(2000) -- For OnPremises Orchestarator, authentication token
DECLARE @params NVARCHAR(2000) 
DECLARE @orchestrator_url varchar(500) = '<Your Orchestrator URL>' -- Your OnPremises Orchestarator URL
DECLARE @jsonResponse NVARCHAR(4000) -- Response from API


/********************** Authenticate and get a token **********************/
SET @method='POST';
SET @url = @orchestrator_url + '/api/Account/Authenticate'; -- onPrem auth API URL
SET @token=''
SET @params = '{
    "password": "passwordGoesHere",
    "usernameOrEmailAddress": "userNameHere",
    "tenancyName": "Default"
}';  
SET @jsonResponse = (SELECT dbo.Call_GetPostAPI(@method,@url,@token,@params))
-- SELECT * FROM OpenJson(@jsonResponse);
SET @token = (SELECT dbo.Get_JSON_Value(@jsonResponse, 'result')) 


/********************** Get Queue details by name **********************/
SET @method='GET';
SET @url = @orchestrator_url + '/odata/QueueDefinitions?$filter=Name eq ''Queue_Test''';
SET @params = '';  
SET @jsonResponse = (SELECT dbo.Call_GetPostAPI(@method,@url,@token,@params))
-- SELECT * FROM OpenJson(@jsonResponse);
DECLARE @queueId varchar(20)
SET @queueId = (SELECT dbo.Get_JSON_Value(@jsonResponse, 'Id'))


/********************** Add item to Queue **********************/
SET @method='POST';
SET @url = @orchestrator_url + '/odata/Queues/UiPathODataSvc.AddQueueItem';
SET @params = '{
    "itemData": {        
        "Priority": "Normal",
        "Name": "QueueName",
        "SpecificContent": {
            "Info": "#String",
            "Name": "Test Name",
            "Age": 32,
            "Status": false            
        },
        "Reference": "Test32"
    }
}';  
SET @jsonResponse = (SELECT dbo.Call_GetPostAPI(@method,@url,@token,@params))
-- SELECT * FROM OpenJson(@jsonResponse);
SELECT @jsonResponse